#include <stdio.h>

#include "microsd.h"

static int ready_wait = 100;

static FILE *inf = NULL;

int
microsd_card_ready ()
{
  if (ready_wait < 0)
    ready_wait ++;
  if (ready_wait == -1)
    ready_wait = 100;
  if (ready_wait > 0)
    ready_wait --;
  return ready_wait <= 0;
}

int
microsd_get_block (unsigned long blockno, void *buf)
{
  ready_wait = -100;

  printf("\033[32mmicrosd: read block %08x\033[0m\n", blockno);
  if (inf == NULL)
    inf = fopen("microsd.dat", "rb");
  if (!inf)
    return 1;
  if (fseek (inf, blockno * 512, SEEK_SET))
    return 1;
  if (fread (buf, 1, 512, inf) != 512)
    return 1;
  return 0;
}
